<template>
    <div>
        <v-snackbar v-model="snackSuc" top color="success">Listo, ingresa a tu correo para continuar con el proceso.</v-snackbar>
        <v-snackbar v-model="snackErr" top color="error">{{ msjError }}</v-snackbar>
        <v-dialog v-model="visible" persistent max-width="400">
            <v-card>
                <v-card-title>Solicita tu cambio de contraseña</v-card-title>
                <v-card-text>
                    <span>Ingresa los siguientes datos asociados a tu cuenta.</span>
                    <v-form v-model="isValid" ref="recoverPass">
                        <v-row class="mt-4">
                            <v-text-field
                                label="CURP"
                                :rules="rulesCURP"
                                prepend-icon="fas fa-id-card"
                                v-model="recoverPass.curp" 
                                outlined
                                required/>
                            <v-text-field
                                label="Correo electrónico"
                                :rules="rulesEmail"
                                prepend-icon="fas fa-at"
                                v-model="recoverPass.email" 
                                outlined
                                @keydown.enter="actionRecoverPassword(recoverPass)"
                                required/>
                        </v-row>
                        <v-row>
                            <v-col cols="12" sm="6">
                                <v-btn :disabled="!isValid || snackSuc" block color="success" @click="actionRecoverPassword(recoverPass)">Solicitar</v-btn>
                            </v-col>
                            <v-col cols="12" sm="6">
                                <v-btn block color="error" @click="closeForm">Cancelar</v-btn>
                            </v-col>
                        </v-row>
                    </v-form>
                </v-card-text>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
import EventBus from "../../bus";
import { mapActions } from "vuex";

export default {
    name: "FormRecoverPassword",
    props:["visible"],
    data: () => ({
        isValid:true,
        snackSuc:false,
        snackErr: false,
        msjError:"",
        recoverPass:{
            curp:"",
            email:""
        },
        rulesEmail: [
			value => !!value || "Campo requerido",
			value => {
				const pattern = /^\w+([\.-]?\w+)*@\w+(\.com||\.com\.mx||\.mx||\.es)+$/;
				return pattern.test(value) || "Correo electrónico inválido";
			}
		],
        rulesCURP: [
			value => !!value || "Campo requerido",
			value =>
				(value || "").length === 18 || "18 carácteres obligatorios",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'",<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo letras y números";
			}
		],
    }),
    methods:{
        ...mapActions(["actionRecoverPassword"]),
        correct(){
            this.snackSuc = true;
            setTimeout(() => {
                this.snackSuc = false;
                this.closeForm();
            }, 3000)
        },
        closeForm(){
            EventBus.$emit("closeRecoverPassword");
            this.$refs.recoverPass.reset();
        }
    },
    watch:{
        "recoverPass.curp": function(val){
            if(this.recoverPass.curp !== undefined){
                this.recoverPass.curp = this.recoverPass.curp.toUpperCase();
            }
        }
    },
    mounted(){
        // cierra el formulario de recuperación de contraseña con la tecla ESC
		document.addEventListener("keydown", event => {
            const keyWhich = event.which;
			if (keyWhich == 27) {
                this.closeForm();
			}
        });
        
        // verifica si la peticion es correcta
        EventBus.$on("responseRecoverPassword",(msj) => {
            if(msj === "Usuario inexistente"){
                this.msjError = msj;
                this.snackErr = true;
                setTimeout(() => {
                    this.snackErr = false;
                }, 2500);
            }else{
                this.correct();
            }
        })
    }
}
</script>